var expect = require('chai').expect;
var sinon = require('sinon');
var person = require('../../../models/person');
var express = require('express');

describe('people routes tests', function() {
  var sandbox;
  var router;
  
  beforeEach(function() {
    sandbox = sinon.sandbox.create();
    
    sandbox.stub(express, 'Router').returns({
      get: sandbox.spy(),
    });

    router = require('../../../routes/people');
  });
  
  afterEach(function() {
    sandbox.restore();
  });

  it('should register handler for get /', function() {
     expect(router.get.calledWith('/', sinon.match.any)).to.be.true;
  });
  
  it('handler for get / calls model all function', function(done) {
    var samplePeople = [{}, {}];
    
    sinon.stub(person, 'all', function(callback) {
      callback(null, samplePeople);
    });

    var req = {};
    
    var res = {
      send: function(data) {
        expect(data).to.be.eql(samplePeople);
        done();
      }
    };
    
    var handler = router.get.firstCall.args[1];

    handler(req, res);
  });
});
